#include "3sumclosest.h"

int Solution::threeSumClosest(std::vector<int>& nums, int target) {
	std::unordered_map<int, int> map;

	int ans = INT_MAX;

	std::sort(nums.begin(), nums.end());

	for (int i = 0; i < nums.size(); i++)
		map[nums[i]] = i;

	for (int i = 0; i < nums.size(); i++)
	{
		for (int j = i + 1; j < nums.size(); j++)
		{
			int required = (target - (nums[i] + nums[j])) * -1;

			if (map.count(required))
				return nums[i] + nums[j] + required;

			//Find closest alternative
			int index = j+1;
			int current = nums[j+1];
			while (gettingCloser(required, nums[++index], current)) {
				current = nums[index];
			}

			//See if closest alternative is closer
			if (std::abs(required - current) < std::abs(target - ans))
				ans = current + nums[i] + nums[j];
		}
	}

	return ans;
}

bool Solution::gettingCloser(int target, int newVal, int current) {
	return std::abs(target - newVal) < std::abs(target - current);
}